// src/internal/connection-args.ts
var isValidConnArgs = (connArgs) => {
  return "endpointId" in connArgs && "reconnection" in connArgs;
};
var encodeConnectionArgs = (connArgs) => {
  if (isValidConnArgs(connArgs))
    return JSON.stringify(connArgs);
  throw new TypeError("Invalid ConnectionArgs");
};
var decodeConnectionArgs = (encodedConnArgs) => {
  try {
    const connArgs = JSON.parse(encodedConnArgs);
    return isValidConnArgs(connArgs) ? connArgs : null;
  } catch {
    return null;
  }
};

export {
  encodeConnectionArgs,
  decodeConnectionArgs
};
